From 535523dbdd70e8520422a7b6bbeef42f1f9663a6 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sun, 26 Nov 2023 18:02:28 +0100
Subject: [PATCH 11/54] feat: move apply revealer to main headerbar as linked
 box

---
 lact-gui/src/app/apply_box.rs                 | 57 +++++++++++++
 lact-gui/src/app/apply_revealer.rs            | 50 -----------
 .../src/app/{toolbars.rs => gpu_selector.rs}  | 33 ++------
 lact-gui/src/app/mod.rs                       | 82 +++++++++----------
 4 files changed, 105 insertions(+), 117 deletions(-)
 create mode 100644 lact-gui/src/app/apply_box.rs
 delete mode 100644 lact-gui/src/app/apply_revealer.rs
 rename lact-gui/src/app/{toolbars.rs => gpu_selector.rs} (55%)

diff --git a/lact-gui/src/app/apply_box.rs b/lact-gui/src/app/apply_box.rs
new file mode 100644
index 00000000..58054b2d
--- /dev/null
+++ b/lact-gui/src/app/apply_box.rs
@@ -0,0 +1,57 @@
+use gtk::prelude::*;
+use gtk::*;
+
+#[derive(Clone)]
+pub struct ApplyBox {
+    pub container: Box,
+    apply_button: Button,
+    reset_button: Button,
+}
+
+impl ApplyBox {
+    pub fn new() -> Self {
+        let container = Box::builder()
+            .orientation(Orientation::Horizontal)
+            .css_classes(["linked"])
+            .visible(false)
+            .build();
+
+        let apply_button = Button::builder()
+            .css_classes(["suggested-action"])
+            .label("Apply")
+            .build();
+        let reset_button = Button::builder()
+            .icon_name("view-refresh-symbolic")
+            .tooltip_text("Reset")
+            .build();
+
+        container.append(&apply_button);
+        container.append(&reset_button);
+
+        Self {
+            container,
+            apply_button,
+            reset_button,
+        }
+    }
+
+    pub fn show(&self) {
+        self.container.set_visible(true);
+    }
+
+    pub fn hide(&self) {
+        self.container.set_visible(false);
+    }
+
+    pub fn connect_apply_button_clicked<F: Fn() + 'static>(&self, f: F) {
+        self.apply_button.connect_clicked(move |_| {
+            f();
+        });
+    }
+
+    pub fn connect_reset_button_clicked<F: Fn() + 'static>(&self, f: F) {
+        self.reset_button.connect_clicked(move |_| {
+            f();
+        });
+    }
+}
diff --git a/lact-gui/src/app/toolbars.rs b/lact-gui/src/app/gpu_selector.rs
similarity index 55%
rename from lact-gui/src/app/toolbars.rs
rename to lact-gui/src/app/gpu_selector.rs
index d8afe01b..4ef757bb 100644
--- a/lact-gui/src/app/toolbars.rs
+++ b/lact-gui/src/app/gpu_selector.rs
@@ -4,55 +4,40 @@ use lact_client::schema::DeviceListEntry;
 use pango::EllipsizeMode;
 
 #[derive(Clone)]
-pub struct Toolbars {
-    pub headerbar: libadwaita::HeaderBar,
-    pub gpu_selector: ComboBoxText,
-    pub title: libadwaita::WindowTitle,
+pub struct GpuSelector {
+    pub dropdown: ComboBoxText,
 }
 
-impl Toolbars {
+impl GpuSelector {
     pub fn new() -> Self {
-        let title = libadwaita::WindowTitle::builder()
-            .title("Information")
-            .build();
-
-        let headerbar = libadwaita::HeaderBar::builder()
-            .title_widget(&title)
-            .show_title(true)
-            .build();
-
         // WARN: gtk::ComboBoxText is deprecated, use gtk::DropDown instead
-        let gpu_selector = ComboBoxText::builder()
+        let dropdown = ComboBoxText::builder()
             .margin_top(12)
             .margin_bottom(12)
             .margin_start(12)
             .margin_end(12)
             .build();
 
-        Self {
-            headerbar,
-            gpu_selector,
-            title,
-        }
+        Self { dropdown }
     }
 
     pub fn set_devices(&self, gpus: &[DeviceListEntry<'_>]) {
         for (i, entry) in gpus.iter().enumerate() {
             let name = format!("{i}: {}", entry.name.unwrap_or_default());
-            self.gpu_selector.append(Some(entry.id), &name);
+            self.dropdown.append(Some(entry.id), &name);
         }
 
         // limits the length of gpu names in combobox
-        for cell in self.gpu_selector.cells() {
+        for cell in self.dropdown.cells() {
             cell.set_property("width-chars", 10);
             cell.set_property("ellipsize", EllipsizeMode::End);
         }
 
-        self.gpu_selector.set_active(Some(0));
+        self.dropdown.set_active(Some(0));
     }
 
     pub fn connect_gpu_selection_changed<F: Fn(String) + 'static>(&self, f: F) {
-        self.gpu_selector.connect_changed(move |gpu_selector| {
+        self.dropdown.connect_changed(move |gpu_selector| {
             if let Some(selected_id) = gpu_selector.active_id() {
                 f(selected_id.to_string());
             }
diff --git a/lact-gui/src/app/mod.rs b/lact-gui/src/app/mod.rs
index e5b9fa98..71bed330 100644
--- a/lact-gui/src/app/mod.rs
+++ b/lact-gui/src/app/mod.rs
@@ -1,26 +1,26 @@
-mod apply_revealer;
+mod apply_box;
+mod gpu_selector;
 mod info_row;
 mod page_section;
 mod root_stack;
-mod toolbars;
 
+use self::apply_box::ApplyBox;
 use crate::{APP_ID, GUI_VERSION};
 use anyhow::{anyhow, Context};
-use apply_revealer::ApplyRevealer;
 use glib::clone;
+use gpu_selector::GpuSelector;
 use gtk::glib::{timeout_future, ControlFlow};
 use gtk::{gio::ApplicationFlags, prelude::*, *};
 use lact_client::schema::request::{ConfirmCommand, SetClocksCommand};
 use lact_client::schema::DeviceStats;
 use lact_client::DaemonClient;
 use lact_daemon::MODULE_CONF_PATH;
-use libadwaita::prelude::{AdwApplicationWindowExt, MessageDialogExt};
+use libadwaita::prelude::{AdwApplicationWindowExt, MessageDialogExt, NavigationPageExt};
 use root_stack::RootStack;
 use std::cell::RefCell;
 use std::rc::Rc;
 use std::sync::atomic::AtomicBool;
 use std::time::Duration;
-use toolbars::Toolbars;
 use tracing::{debug, error, trace, warn};
 
 // In ms
@@ -30,9 +30,9 @@ const STATS_POLL_INTERVAL: u64 = 250;
 pub struct App {
     application: libadwaita::Application,
     pub window: libadwaita::ApplicationWindow,
-    pub toolbars: Toolbars,
+    pub gpu_selector: GpuSelector,
     root_stack: RootStack,
-    apply_revealer: ApplyRevealer,
+    apply_box: ApplyBox,
     daemon_client: DaemonClient,
 }
 
@@ -40,7 +40,7 @@ impl App {
     pub fn new(daemon_client: DaemonClient) -> Self {
         let application = libadwaita::Application::new(Some(APP_ID), ApplicationFlags::default());
 
-        let toolbars = Toolbars::new();
+        let gpu_selector = GpuSelector::new();
         let window = libadwaita::ApplicationWindow::builder()
             .title("LACT")
             .default_width(700)
@@ -62,24 +62,14 @@ impl App {
 
         let root_stack = RootStack::new(window.clone(), system_info, daemon_client.embedded);
 
-        {
-            let stack = root_stack.container.clone();
-            let title = toolbars.title.clone();
-            root_stack.container.connect_visible_child_notify(move |_| {
-                if let Some(child) = stack.visible_child() {
-                    title.set_title(stack.page(&child).title().unwrap().as_str())
-                }
-            });
-        }
-
         let root_view = libadwaita::ToolbarView::new();
 
-        root_view.add_top_bar(&toolbars.headerbar);
-        root_view.set_content(Some(&root_stack.container));
-
-        let apply_revealer = ApplyRevealer::new();
+        let root_view_headerbar = libadwaita::HeaderBar::builder().show_title(true).build();
+        let apply_box = ApplyBox::new();
+        root_view_headerbar.pack_end(&apply_box.container);
 
-        root_view.add_bottom_bar(&apply_revealer.container);
+        root_view.add_top_bar(&root_view_headerbar);
+        root_view.set_content(Some(&root_stack.container));
 
         let sidebar_view = libadwaita::ToolbarView::new();
 
@@ -88,11 +78,7 @@ impl App {
             .vexpand(true)
             .build();
         stack_sidebar.remove_css_class("sidebar");
-        sidebar_view.add_top_bar(
-            &libadwaita::HeaderBar::builder()
-                .title_widget(&libadwaita::WindowTitle::builder().title("LACT").build())
-                .build(),
-        );
+        sidebar_view.add_top_bar(&libadwaita::HeaderBar::builder().show_title(true).build());
         sidebar_view.set_content(Some(
             &ScrolledWindow::builder()
                 .child(&stack_sidebar)
@@ -100,8 +86,12 @@ impl App {
                 .hscrollbar_policy(PolicyType::Never)
                 .build(),
         ));
-        sidebar_view.add_bottom_bar(&toolbars.gpu_selector);
+        sidebar_view.add_bottom_bar(&gpu_selector.dropdown);
 
+        let root_nav_page = libadwaita::NavigationPage::builder()
+            .child(&root_view)
+            .title("Information")
+            .build();
         let split_view = libadwaita::NavigationSplitView::builder()
             .sidebar(
                 &libadwaita::NavigationPage::builder()
@@ -109,11 +99,7 @@ impl App {
                     .title("LACT")
                     .build(),
             )
-            .content(
-                &libadwaita::NavigationPage::builder()
-                    .child(&root_view)
-                    .build(),
-            )
+            .content(&root_nav_page)
             .build();
 
         {
@@ -132,6 +118,16 @@ impl App {
             });
         }
 
+        {
+            let stack = root_stack.container.clone();
+            let root_nav_page = root_nav_page.clone();
+            root_stack.container.connect_visible_child_notify(move |_| {
+                if let Some(child) = stack.visible_child() {
+                    root_nav_page.set_title(stack.page(&child).title().unwrap().as_str())
+                }
+            });
+        }
+
         let breakpoint = libadwaita::Breakpoint::new(libadwaita::BreakpointCondition::new_length(
             libadwaita::BreakpointConditionLengthType::MaxWidth,
             800.0,
@@ -145,9 +141,9 @@ impl App {
         App {
             application,
             window,
-            toolbars,
+            gpu_selector,
             root_stack,
-            apply_revealer,
+            apply_box,
             daemon_client,
         }
     }
@@ -159,7 +155,7 @@ impl App {
 
                 let current_gpu_id = Rc::new(RefCell::new(String::new()));
 
-                app.toolbars.connect_gpu_selection_changed(clone!(@strong app, @strong current_gpu_id => move |gpu_id| {
+                app.gpu_selector.connect_gpu_selection_changed(clone!(@strong app, @strong current_gpu_id => move |gpu_id| {
                     debug!("GPU Selection changed");
                     app.set_info(&gpu_id);
                     *current_gpu_id.borrow_mut() = gpu_id;
@@ -171,7 +167,7 @@ impl App {
                     .list_devices()
                     .expect("Could not list devices");
                 let devices = devices_buf.inner().expect("Could not access devices");
-                app.toolbars.set_devices(&devices);
+                app.gpu_selector.set_devices(&devices);
 
                 app.root_stack.oc_page.clocks_frame.connect_clocks_reset(clone!(@strong app, @strong current_gpu_id => move || {
                     debug!("Resetting clocks");
@@ -190,7 +186,7 @@ impl App {
                     }
                 }));
 
-                app.apply_revealer.connect_apply_button_clicked(
+                app.apply_box.connect_apply_button_clicked(
                     clone!(@strong app, @strong current_gpu_id => move || {
                         glib::idle_add_local_once(clone!(@strong app, @strong current_gpu_id => move || {
                             if let Err(err) = app.apply_settings(current_gpu_id.clone()) {
@@ -204,7 +200,7 @@ impl App {
                         }));
                     }),
                 );
-                app.apply_revealer.connect_reset_button_clicked(clone!(@strong app, @strong current_gpu_id => move || {
+                app.apply_box.connect_reset_button_clicked(clone!(@strong app, @strong current_gpu_id => move || {
                     let gpu_id = current_gpu_id.borrow().clone();
                     app.set_initial(&gpu_id)
                 }));
@@ -351,9 +347,9 @@ impl App {
 
         // Show apply button on setting changes
         // This is done here because new widgets may appear after applying settings (like fan curve points) which should be connected
-        let show_revealer = clone!(@strong self.apply_revealer as apply_revealer => move || {
+        let show_revealer = clone!(@strong self.apply_box as apply_box => move || {
                 debug!("settings changed, showing apply button");
-                apply_revealer.show();
+                apply_box.show();
         });
 
         self.root_stack
@@ -364,7 +360,7 @@ impl App {
             .oc_page
             .connect_settings_changed(show_revealer);
 
-        self.apply_revealer.hide();
+        self.apply_box.hide();
     }
 
     fn start_stats_update_loop(&self, current_gpu_id: Rc<RefCell<String>>) {

